#!/usr/bin/gnuplot

set term x11 enhanced

set xl "X / cm"
set yl "Y / cm"
set zl "Z / cm"

set zeroaxis
set nokey

load "ciselnik.plt"

sc=2.5
sc=1
set xr [sc*x1:sc*x2]
set yr [sc*y1:sc*y2]

set ticslevel 0
set zr [0:200]

set size ratio -1
set view 42,324,1,1

call "popisky2.plt" "front"
call "deska_popis2.plt" "font \"Fixed, 8\" front"

tmp=0.03
set label "S" at graph 0.5,graph 1+tmp,0 center
set label "V" at graph 1.0+tmp,graph 0.5,0 center

set style line 1 lt 1 lw 2.5 pt 1 ps 1.5
set style line 2 lt 1 lw 1 pt 1
set style line 3 lt 3 lw 1.5
set style line 4 lt 7 lw 0.5
set style line 5 lt 3 lw 0.5 pt 5 ps 0.75
set style line 6 lt -1 lw 3
set style line 7 lt 6 lw 3
set style line 8 lt 8 lw 1

sp "stin.dat"         u 3:4:5   w l ls 7,\
   "paprsek.dat"      u 3:4:5   w l ls 8,\
   "datum_prumet.dat" u 4:5:(0) w lp ls 5,\
   "lambert.dat"      u 1:2:(0) w l ls 4,\
   "elipsa.dat"       u 2:3:(0) w d ls 2,\
   "hodin.dat"        u 2:3:(0) w p ls 1,\
   "deska.dat"        u 1:2:(0) w l ls 3,\
   "gnomon.dat"       u 3:4:5   w l ls 6

pa -1


sp "<./sha.awk 270 10 stin.dat"         u 3:4:5   w l ls 7,\
   "<./sha.awk 270 10 paprsek.dat"      u 3:4:5   w l ls 8,\
   "datum_prumet.dat" u 4:5:(0) w lp ls 5,\
   "lambert.dat"      u 1:2:(0) w l ls 4,\
   "elipsa.dat"       u 2:3:(0) w d ls 2,\
   "hodin.dat"        u 2:3:(0) w p ls 1,\
   "deska.dat"        u 1:2:(0) w l ls 3,\
   "<./sha.awk 270 10 gnomon.dat"       u 3:4:5   w l ls 6

pa -1

sp "<./sha.awk  90 15 stin.dat"         u 3:4:5   w l ls 7,\
   "<./sha.awk  90 15 paprsek.dat"      u 3:4:5   w l ls 8,\
   "datum_prumet.dat" u 4:5:(0) w lp ls 5,\
   "lambert.dat"      u 1:2:(0) w l ls 4,\
   "elipsa.dat"       u 2:3:(0) w d ls 2,\
   "hodin.dat"        u 2:3:(0) w p ls 1,\
   "deska.dat"        u 1:2:(0) w l ls 3,\
   "<./sha.awk  90 15 gnomon.dat"       u 3:4:5   w l ls 6

pa -1
q

